package com.steerinfo.baseinfo.meterbasehistarecountd.controller;

import com.steerinfo.framework.controller.BaseRESTfulController;
import com.steerinfo.framework.controller.RESTfulResult;
import com.steerinfo.framework.service.pagehelper.PageList;
import com.steerinfo.framework.utils.collection.ListUtils;
import com.steerinfo.baseinfo.meterbasehistarecountd.model.MeterBaseHisTareCountD;
import com.steerinfo.baseinfo.meterbasehistarecountd.service.IMeterBaseHisTareCountDService;
import com.steerinfo.meterwork.except.MarkerMetException;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.Arrays;
import java.util.HashMap;
import java.util.List;

/**
 * MeterBaseHisTareCountD RESTful接口：
 *
 * @author generator
 * @version 1.0-SNAPSHORT 2021-06-07 05:34
 * 类描述
 * 修订历史：
 * 日期：2021-06-07
 * 作者：generator
 * 参考：
 * 描述：MeterBaseHisTareCountD RESTful接口
 * @Copyright 湖南视拓信息技术股份有限公司. All rights reserved.
 * @see null
 */
@RestController
@RequestMapping("/${api.version}/meterbasehistarecountds")
@Api(value = "/${api.version}/meterbasehistarecountds", tags = "历史皮重计算配置_从表 - MeterBaseHisTareCountDController")
public class MeterBaseHisTareCountDController extends BaseRESTfulController {

    @Autowired
    IMeterBaseHisTareCountDService meterBaseHisTareCountDService;

    @ApiOperation(value = "获取列表", notes = "分页查询")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("meterbasehistarecountd:view")
    @GetMapping(value = "/")
    public RESTfulResult list(@RequestParam HashMap parmas, Integer pageNum, Integer pageSize) {
        try {
            PageList<MeterBaseHisTareCountD> list = meterBaseHisTareCountDService.queryForPage(parmas, pageNum, pageSize);
            return success(list);
        } catch (Exception ex) {
            ex.printStackTrace();
            throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value = "获取列表", notes = "分页模糊查询")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("meterbasehistarecountd:view")
    @GetMapping(value = "/like/")
    public RESTfulResult listLike(@RequestParam HashMap parmas, Integer pageNum, Integer pageSize) {
        try {
            PageList<MeterBaseHisTareCountD> list = meterBaseHisTareCountDService.queryLikeForPage(parmas, pageNum, pageSize);
            return success(list);
        } catch (Exception ex) {
            ex.printStackTrace();
            throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value = "创建", notes = "根据MeterBaseHisTareCountD对象创建")
    @ApiImplicitParam(name = "meterBaseHisTareCountD", value = "详细实体meterBaseHisTareCountD", required = true, dataType = "MeterBaseHisTareCountD")
    //@RequiresPermissions("meterbasehistarecountd:create")
    @PostMapping(value = "/")
    public RESTfulResult add(@ModelAttribute MeterBaseHisTareCountD model) {
        try {
            MeterBaseHisTareCountD meterBaseHisTareCountD = meterBaseHisTareCountDService.add(model);
            return success(meterBaseHisTareCountD);
        } catch (Exception ex) {
            ex.printStackTrace();
            throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value = "获取详细信息", notes = "根据url的id来获取详细信息")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("meterbasehistarecountd:view")
    @GetMapping(value = "/{id}")
    public RESTfulResult get(@PathVariable String id) {
        try {
            MeterBaseHisTareCountD meterBaseHisTareCountD = meterBaseHisTareCountDService.getById(id);
            return success(meterBaseHisTareCountD);
        } catch (Exception ex) {
            ex.printStackTrace();
            throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value = "更新详细信息", notes = "根据url的id来指定更新对象，并根据传过来的meterBaseHisTareCountD信息来更新详细信息")
    @ApiImplicitParams({
            @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String"),
            @ApiImplicitParam(name = "meterBaseHisTareCountD", value = "详细实体meterBaseHisTareCountD", required = true, dataType = "MeterBaseHisTareCountD")
    })
    //@RequiresPermissions("meterbasehistarecountd:update")
    @PutMapping(value = "/{id}", produces = "application/json;charset=UTF-8")
    public RESTfulResult update(@PathVariable String id, @RequestBody MeterBaseHisTareCountD model) {
        try {
            model.setId(id);
            MeterBaseHisTareCountD meterBaseHisTareCountD = meterBaseHisTareCountDService.modify(model);
            return success(meterBaseHisTareCountD);
        } catch (Exception ex) {
            ex.printStackTrace();
            throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value = "删除", notes = "根据url的id来指定删除对象")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("meterbasehistarecountd:delete")
    @DeleteMapping(value = "/{id}")//String
    public RESTfulResult delete(@PathVariable String id) {
        try {
            List<String> list = Arrays.asList(id.split(","));
            if (ListUtils.isNotEmpty(list)) {
                List<String> ids = ListUtils.convertList(list);
                meterBaseHisTareCountDService.delete(ids);
            }
            return success();
        } catch (Exception ex) {
            ex.printStackTrace();
            throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value = "新增详细信息", notes = "根据传过来的meterBaseHisTareCountD信息来新增详细信息")
    @ApiImplicitParams({
            @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String"),
            @ApiImplicitParam(name = "meterBaseHisTareCountD", value = "详细实体meterBaseHisTareCountD", required = true, dataType = "MeterBaseHisTareCountD")
    })
    //@RequiresPermissions("meterbasehistarecountd:update")
    @PostMapping(value = "/insert", produces = "application/json;charset=UTF-8")
    public RESTfulResult insert(@RequestBody MeterBaseHisTareCountD model) {
        RESTfulResult rm = failed();
        try {
            MeterBaseHisTareCountD meterBaseHisTareCountD = meterBaseHisTareCountDService.insert(model);
            return success(meterBaseHisTareCountD);
        } catch (MarkerMetException e) {
            e.printStackTrace();
            rm.setMessage(e.getMessage());
        } catch (Exception ex) {
            ex.printStackTrace();
            rm.setMessage( "操作异常！！");
        }
        return rm;
    }

    @ApiOperation(value = "更新详细信息", notes = "根据传过来的meterBaseHisTareCountD信息来新增详细信息")
    @ApiImplicitParams({
            @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String"),
            @ApiImplicitParam(name = "meterBaseHisTareCountD", value = "详细实体meterBaseHisTareCountD", required = true, dataType = "MeterBaseHisTareCountD")
    })
    //@RequiresPermissions("meterbasehistarecountd:update")
    @PostMapping(value = "/update", produces = "application/json;charset=UTF-8")
    public RESTfulResult update(@RequestBody List<MeterBaseHisTareCountD> models) {
        RESTfulResult rm = failed();
        try {
            int num = meterBaseHisTareCountDService.update(models);
            if (num >= 1) {
                return success(num);
            } else {
                return failed("修改失败");
            }
        } catch (MarkerMetException e) {
            e.printStackTrace();
            rm.setMessage(e.getMessage());
        } catch (Exception ex) {
            ex.printStackTrace();
            rm.setMessage( "操作异常！！");
        }
        return rm;
    }
}
